/*
 *	Preprocessor Library by Parra Studios
 *	A generic header-only preprocessor metaprogramming library.
 *
 *	Copyright (C) 2016 - 2022 Vicente Eduardo Ferrer Garcia <vic798@gmail.com>
 *
 *	Licensed under the Apache License, Version 2.0 (the "License");
 *	you may not use this file except in compliance with the License.
 *	You may obtain a copy of the License at
 *
 *		http://www.apache.org/licenses/LICENSE-2.0
 *
 *	Unless required by applicable law or agreed to in writing, software
 *	distributed under the License is distributed on an "AS IS" BASIS,
 *	WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *	See the License for the specific language governing permissions and
 *	limitations under the License.
 *
 */

#ifndef PREPROCESSOR_ARITHMETIC_H
#define PREPROCESSOR_ARITHMETIC_H 1

/* -- Headers -- */

#include <preprocessor/preprocessor_api.h>

#ifdef __cplusplus
extern "C" {
#endif

/* -- Definitions -- */

#define PREPROCESSOR_ARITHMETIC_SIZE 256

#define PREPROCESSOR_INCREMENT_IMPL_0 1
#define PREPROCESSOR_INCREMENT_IMPL_1 2
#define PREPROCESSOR_INCREMENT_IMPL_2 3
#define PREPROCESSOR_INCREMENT_IMPL_3 4
#define PREPROCESSOR_INCREMENT_IMPL_4 5
#define PREPROCESSOR_INCREMENT_IMPL_5 6
#define PREPROCESSOR_INCREMENT_IMPL_6 7
#define PREPROCESSOR_INCREMENT_IMPL_7 8
#define PREPROCESSOR_INCREMENT_IMPL_8 9
#define PREPROCESSOR_INCREMENT_IMPL_9 10
#define PREPROCESSOR_INCREMENT_IMPL_10 11
#define PREPROCESSOR_INCREMENT_IMPL_11 12
#define PREPROCESSOR_INCREMENT_IMPL_12 13
#define PREPROCESSOR_INCREMENT_IMPL_13 14
#define PREPROCESSOR_INCREMENT_IMPL_14 15
#define PREPROCESSOR_INCREMENT_IMPL_15 16
#define PREPROCESSOR_INCREMENT_IMPL_16 17
#define PREPROCESSOR_INCREMENT_IMPL_17 18
#define PREPROCESSOR_INCREMENT_IMPL_18 19
#define PREPROCESSOR_INCREMENT_IMPL_19 20
#define PREPROCESSOR_INCREMENT_IMPL_20 21
#define PREPROCESSOR_INCREMENT_IMPL_21 22
#define PREPROCESSOR_INCREMENT_IMPL_22 23
#define PREPROCESSOR_INCREMENT_IMPL_23 24
#define PREPROCESSOR_INCREMENT_IMPL_24 25
#define PREPROCESSOR_INCREMENT_IMPL_25 26
#define PREPROCESSOR_INCREMENT_IMPL_26 27
#define PREPROCESSOR_INCREMENT_IMPL_27 28
#define PREPROCESSOR_INCREMENT_IMPL_28 29
#define PREPROCESSOR_INCREMENT_IMPL_29 30
#define PREPROCESSOR_INCREMENT_IMPL_30 31
#define PREPROCESSOR_INCREMENT_IMPL_31 32
#define PREPROCESSOR_INCREMENT_IMPL_32 33
#define PREPROCESSOR_INCREMENT_IMPL_33 34
#define PREPROCESSOR_INCREMENT_IMPL_34 35
#define PREPROCESSOR_INCREMENT_IMPL_35 36
#define PREPROCESSOR_INCREMENT_IMPL_36 37
#define PREPROCESSOR_INCREMENT_IMPL_37 38
#define PREPROCESSOR_INCREMENT_IMPL_38 39
#define PREPROCESSOR_INCREMENT_IMPL_39 40
#define PREPROCESSOR_INCREMENT_IMPL_40 41
#define PREPROCESSOR_INCREMENT_IMPL_41 42
#define PREPROCESSOR_INCREMENT_IMPL_42 43
#define PREPROCESSOR_INCREMENT_IMPL_43 44
#define PREPROCESSOR_INCREMENT_IMPL_44 45
#define PREPROCESSOR_INCREMENT_IMPL_45 46
#define PREPROCESSOR_INCREMENT_IMPL_46 47
#define PREPROCESSOR_INCREMENT_IMPL_47 48
#define PREPROCESSOR_INCREMENT_IMPL_48 49
#define PREPROCESSOR_INCREMENT_IMPL_49 50
#define PREPROCESSOR_INCREMENT_IMPL_50 51
#define PREPROCESSOR_INCREMENT_IMPL_51 52
#define PREPROCESSOR_INCREMENT_IMPL_52 53
#define PREPROCESSOR_INCREMENT_IMPL_53 54
#define PREPROCESSOR_INCREMENT_IMPL_54 55
#define PREPROCESSOR_INCREMENT_IMPL_55 56
#define PREPROCESSOR_INCREMENT_IMPL_56 57
#define PREPROCESSOR_INCREMENT_IMPL_57 58
#define PREPROCESSOR_INCREMENT_IMPL_58 59
#define PREPROCESSOR_INCREMENT_IMPL_59 60
#define PREPROCESSOR_INCREMENT_IMPL_60 61
#define PREPROCESSOR_INCREMENT_IMPL_61 62
#define PREPROCESSOR_INCREMENT_IMPL_62 63
#define PREPROCESSOR_INCREMENT_IMPL_63 64
#define PREPROCESSOR_INCREMENT_IMPL_64 65
#define PREPROCESSOR_INCREMENT_IMPL_65 66
#define PREPROCESSOR_INCREMENT_IMPL_66 67
#define PREPROCESSOR_INCREMENT_IMPL_67 68
#define PREPROCESSOR_INCREMENT_IMPL_68 69
#define PREPROCESSOR_INCREMENT_IMPL_69 70
#define PREPROCESSOR_INCREMENT_IMPL_70 71
#define PREPROCESSOR_INCREMENT_IMPL_71 72
#define PREPROCESSOR_INCREMENT_IMPL_72 73
#define PREPROCESSOR_INCREMENT_IMPL_73 74
#define PREPROCESSOR_INCREMENT_IMPL_74 75
#define PREPROCESSOR_INCREMENT_IMPL_75 76
#define PREPROCESSOR_INCREMENT_IMPL_76 77
#define PREPROCESSOR_INCREMENT_IMPL_77 78
#define PREPROCESSOR_INCREMENT_IMPL_78 79
#define PREPROCESSOR_INCREMENT_IMPL_79 80
#define PREPROCESSOR_INCREMENT_IMPL_80 81
#define PREPROCESSOR_INCREMENT_IMPL_81 82
#define PREPROCESSOR_INCREMENT_IMPL_82 83
#define PREPROCESSOR_INCREMENT_IMPL_83 84
#define PREPROCESSOR_INCREMENT_IMPL_84 85
#define PREPROCESSOR_INCREMENT_IMPL_85 86
#define PREPROCESSOR_INCREMENT_IMPL_86 87
#define PREPROCESSOR_INCREMENT_IMPL_87 88
#define PREPROCESSOR_INCREMENT_IMPL_88 89
#define PREPROCESSOR_INCREMENT_IMPL_89 90
#define PREPROCESSOR_INCREMENT_IMPL_90 91
#define PREPROCESSOR_INCREMENT_IMPL_91 92
#define PREPROCESSOR_INCREMENT_IMPL_92 93
#define PREPROCESSOR_INCREMENT_IMPL_93 94
#define PREPROCESSOR_INCREMENT_IMPL_94 95
#define PREPROCESSOR_INCREMENT_IMPL_95 96
#define PREPROCESSOR_INCREMENT_IMPL_96 97
#define PREPROCESSOR_INCREMENT_IMPL_97 98
#define PREPROCESSOR_INCREMENT_IMPL_98 99
#define PREPROCESSOR_INCREMENT_IMPL_99 100
#define PREPROCESSOR_INCREMENT_IMPL_100 101
#define PREPROCESSOR_INCREMENT_IMPL_101 102
#define PREPROCESSOR_INCREMENT_IMPL_102 103
#define PREPROCESSOR_INCREMENT_IMPL_103 104
#define PREPROCESSOR_INCREMENT_IMPL_104 105
#define PREPROCESSOR_INCREMENT_IMPL_105 106
#define PREPROCESSOR_INCREMENT_IMPL_106 107
#define PREPROCESSOR_INCREMENT_IMPL_107 108
#define PREPROCESSOR_INCREMENT_IMPL_108 109
#define PREPROCESSOR_INCREMENT_IMPL_109 110
#define PREPROCESSOR_INCREMENT_IMPL_110 111
#define PREPROCESSOR_INCREMENT_IMPL_111 112
#define PREPROCESSOR_INCREMENT_IMPL_112 113
#define PREPROCESSOR_INCREMENT_IMPL_113 114
#define PREPROCESSOR_INCREMENT_IMPL_114 115
#define PREPROCESSOR_INCREMENT_IMPL_115 116
#define PREPROCESSOR_INCREMENT_IMPL_116 117
#define PREPROCESSOR_INCREMENT_IMPL_117 118
#define PREPROCESSOR_INCREMENT_IMPL_118 119
#define PREPROCESSOR_INCREMENT_IMPL_119 120
#define PREPROCESSOR_INCREMENT_IMPL_120 121
#define PREPROCESSOR_INCREMENT_IMPL_121 122
#define PREPROCESSOR_INCREMENT_IMPL_122 123
#define PREPROCESSOR_INCREMENT_IMPL_123 124
#define PREPROCESSOR_INCREMENT_IMPL_124 125
#define PREPROCESSOR_INCREMENT_IMPL_125 126
#define PREPROCESSOR_INCREMENT_IMPL_126 127
#define PREPROCESSOR_INCREMENT_IMPL_127 128
#define PREPROCESSOR_INCREMENT_IMPL_128 129
#define PREPROCESSOR_INCREMENT_IMPL_129 130
#define PREPROCESSOR_INCREMENT_IMPL_130 131
#define PREPROCESSOR_INCREMENT_IMPL_131 132
#define PREPROCESSOR_INCREMENT_IMPL_132 133
#define PREPROCESSOR_INCREMENT_IMPL_133 134
#define PREPROCESSOR_INCREMENT_IMPL_134 135
#define PREPROCESSOR_INCREMENT_IMPL_135 136
#define PREPROCESSOR_INCREMENT_IMPL_136 137
#define PREPROCESSOR_INCREMENT_IMPL_137 138
#define PREPROCESSOR_INCREMENT_IMPL_138 139
#define PREPROCESSOR_INCREMENT_IMPL_139 140
#define PREPROCESSOR_INCREMENT_IMPL_140 141
#define PREPROCESSOR_INCREMENT_IMPL_141 142
#define PREPROCESSOR_INCREMENT_IMPL_142 143
#define PREPROCESSOR_INCREMENT_IMPL_143 144
#define PREPROCESSOR_INCREMENT_IMPL_144 145
#define PREPROCESSOR_INCREMENT_IMPL_145 146
#define PREPROCESSOR_INCREMENT_IMPL_146 147
#define PREPROCESSOR_INCREMENT_IMPL_147 148
#define PREPROCESSOR_INCREMENT_IMPL_148 149
#define PREPROCESSOR_INCREMENT_IMPL_149 150
#define PREPROCESSOR_INCREMENT_IMPL_150 151
#define PREPROCESSOR_INCREMENT_IMPL_151 152
#define PREPROCESSOR_INCREMENT_IMPL_152 153
#define PREPROCESSOR_INCREMENT_IMPL_153 154
#define PREPROCESSOR_INCREMENT_IMPL_154 155
#define PREPROCESSOR_INCREMENT_IMPL_155 156
#define PREPROCESSOR_INCREMENT_IMPL_156 157
#define PREPROCESSOR_INCREMENT_IMPL_157 158
#define PREPROCESSOR_INCREMENT_IMPL_158 159
#define PREPROCESSOR_INCREMENT_IMPL_159 160
#define PREPROCESSOR_INCREMENT_IMPL_160 161
#define PREPROCESSOR_INCREMENT_IMPL_161 162
#define PREPROCESSOR_INCREMENT_IMPL_162 163
#define PREPROCESSOR_INCREMENT_IMPL_163 164
#define PREPROCESSOR_INCREMENT_IMPL_164 165
#define PREPROCESSOR_INCREMENT_IMPL_165 166
#define PREPROCESSOR_INCREMENT_IMPL_166 167
#define PREPROCESSOR_INCREMENT_IMPL_167 168
#define PREPROCESSOR_INCREMENT_IMPL_168 169
#define PREPROCESSOR_INCREMENT_IMPL_169 170
#define PREPROCESSOR_INCREMENT_IMPL_170 171
#define PREPROCESSOR_INCREMENT_IMPL_171 172
#define PREPROCESSOR_INCREMENT_IMPL_172 173
#define PREPROCESSOR_INCREMENT_IMPL_173 174
#define PREPROCESSOR_INCREMENT_IMPL_174 175
#define PREPROCESSOR_INCREMENT_IMPL_175 176
#define PREPROCESSOR_INCREMENT_IMPL_176 177
#define PREPROCESSOR_INCREMENT_IMPL_177 178
#define PREPROCESSOR_INCREMENT_IMPL_178 179
#define PREPROCESSOR_INCREMENT_IMPL_179 180
#define PREPROCESSOR_INCREMENT_IMPL_180 181
#define PREPROCESSOR_INCREMENT_IMPL_181 182
#define PREPROCESSOR_INCREMENT_IMPL_182 183
#define PREPROCESSOR_INCREMENT_IMPL_183 184
#define PREPROCESSOR_INCREMENT_IMPL_184 185
#define PREPROCESSOR_INCREMENT_IMPL_185 186
#define PREPROCESSOR_INCREMENT_IMPL_186 187
#define PREPROCESSOR_INCREMENT_IMPL_187 188
#define PREPROCESSOR_INCREMENT_IMPL_188 189
#define PREPROCESSOR_INCREMENT_IMPL_189 190
#define PREPROCESSOR_INCREMENT_IMPL_190 191
#define PREPROCESSOR_INCREMENT_IMPL_191 192
#define PREPROCESSOR_INCREMENT_IMPL_192 193
#define PREPROCESSOR_INCREMENT_IMPL_193 194
#define PREPROCESSOR_INCREMENT_IMPL_194 195
#define PREPROCESSOR_INCREMENT_IMPL_195 196
#define PREPROCESSOR_INCREMENT_IMPL_196 197
#define PREPROCESSOR_INCREMENT_IMPL_197 198
#define PREPROCESSOR_INCREMENT_IMPL_198 199
#define PREPROCESSOR_INCREMENT_IMPL_199 200
#define PREPROCESSOR_INCREMENT_IMPL_200 201
#define PREPROCESSOR_INCREMENT_IMPL_201 202
#define PREPROCESSOR_INCREMENT_IMPL_202 203
#define PREPROCESSOR_INCREMENT_IMPL_203 204
#define PREPROCESSOR_INCREMENT_IMPL_204 205
#define PREPROCESSOR_INCREMENT_IMPL_205 206
#define PREPROCESSOR_INCREMENT_IMPL_206 207
#define PREPROCESSOR_INCREMENT_IMPL_207 208
#define PREPROCESSOR_INCREMENT_IMPL_208 209
#define PREPROCESSOR_INCREMENT_IMPL_209 210
#define PREPROCESSOR_INCREMENT_IMPL_210 211
#define PREPROCESSOR_INCREMENT_IMPL_211 212
#define PREPROCESSOR_INCREMENT_IMPL_212 213
#define PREPROCESSOR_INCREMENT_IMPL_213 214
#define PREPROCESSOR_INCREMENT_IMPL_214 215
#define PREPROCESSOR_INCREMENT_IMPL_215 216
#define PREPROCESSOR_INCREMENT_IMPL_216 217
#define PREPROCESSOR_INCREMENT_IMPL_217 218
#define PREPROCESSOR_INCREMENT_IMPL_218 219
#define PREPROCESSOR_INCREMENT_IMPL_219 220
#define PREPROCESSOR_INCREMENT_IMPL_220 221
#define PREPROCESSOR_INCREMENT_IMPL_221 222
#define PREPROCESSOR_INCREMENT_IMPL_222 223
#define PREPROCESSOR_INCREMENT_IMPL_223 224
#define PREPROCESSOR_INCREMENT_IMPL_224 225
#define PREPROCESSOR_INCREMENT_IMPL_225 226
#define PREPROCESSOR_INCREMENT_IMPL_226 227
#define PREPROCESSOR_INCREMENT_IMPL_227 228
#define PREPROCESSOR_INCREMENT_IMPL_228 229
#define PREPROCESSOR_INCREMENT_IMPL_229 230
#define PREPROCESSOR_INCREMENT_IMPL_230 231
#define PREPROCESSOR_INCREMENT_IMPL_231 232
#define PREPROCESSOR_INCREMENT_IMPL_232 233
#define PREPROCESSOR_INCREMENT_IMPL_233 234
#define PREPROCESSOR_INCREMENT_IMPL_234 235
#define PREPROCESSOR_INCREMENT_IMPL_235 236
#define PREPROCESSOR_INCREMENT_IMPL_236 237
#define PREPROCESSOR_INCREMENT_IMPL_237 238
#define PREPROCESSOR_INCREMENT_IMPL_238 239
#define PREPROCESSOR_INCREMENT_IMPL_239 240
#define PREPROCESSOR_INCREMENT_IMPL_240 241
#define PREPROCESSOR_INCREMENT_IMPL_241 242
#define PREPROCESSOR_INCREMENT_IMPL_242 243
#define PREPROCESSOR_INCREMENT_IMPL_243 244
#define PREPROCESSOR_INCREMENT_IMPL_244 245
#define PREPROCESSOR_INCREMENT_IMPL_245 246
#define PREPROCESSOR_INCREMENT_IMPL_246 247
#define PREPROCESSOR_INCREMENT_IMPL_247 248
#define PREPROCESSOR_INCREMENT_IMPL_248 249
#define PREPROCESSOR_INCREMENT_IMPL_249 250
#define PREPROCESSOR_INCREMENT_IMPL_250 251
#define PREPROCESSOR_INCREMENT_IMPL_251 252
#define PREPROCESSOR_INCREMENT_IMPL_252 253
#define PREPROCESSOR_INCREMENT_IMPL_253 254
#define PREPROCESSOR_INCREMENT_IMPL_254 255
#define PREPROCESSOR_INCREMENT_IMPL_255 256
#define PREPROCESSOR_INCREMENT_IMPL_256 257

#define PREPROCESSOR_DECREMENT_IMPL_0 0
#define PREPROCESSOR_DECREMENT_IMPL_1 0
#define PREPROCESSOR_DECREMENT_IMPL_2 1
#define PREPROCESSOR_DECREMENT_IMPL_3 2
#define PREPROCESSOR_DECREMENT_IMPL_4 3
#define PREPROCESSOR_DECREMENT_IMPL_5 4
#define PREPROCESSOR_DECREMENT_IMPL_6 5
#define PREPROCESSOR_DECREMENT_IMPL_7 6
#define PREPROCESSOR_DECREMENT_IMPL_8 7
#define PREPROCESSOR_DECREMENT_IMPL_9 8
#define PREPROCESSOR_DECREMENT_IMPL_10 9
#define PREPROCESSOR_DECREMENT_IMPL_11 10
#define PREPROCESSOR_DECREMENT_IMPL_12 11
#define PREPROCESSOR_DECREMENT_IMPL_13 12
#define PREPROCESSOR_DECREMENT_IMPL_14 13
#define PREPROCESSOR_DECREMENT_IMPL_15 14
#define PREPROCESSOR_DECREMENT_IMPL_16 15
#define PREPROCESSOR_DECREMENT_IMPL_17 16
#define PREPROCESSOR_DECREMENT_IMPL_18 17
#define PREPROCESSOR_DECREMENT_IMPL_19 18
#define PREPROCESSOR_DECREMENT_IMPL_20 19
#define PREPROCESSOR_DECREMENT_IMPL_21 20
#define PREPROCESSOR_DECREMENT_IMPL_22 21
#define PREPROCESSOR_DECREMENT_IMPL_23 22
#define PREPROCESSOR_DECREMENT_IMPL_24 23
#define PREPROCESSOR_DECREMENT_IMPL_25 24
#define PREPROCESSOR_DECREMENT_IMPL_26 25
#define PREPROCESSOR_DECREMENT_IMPL_27 26
#define PREPROCESSOR_DECREMENT_IMPL_28 27
#define PREPROCESSOR_DECREMENT_IMPL_29 28
#define PREPROCESSOR_DECREMENT_IMPL_30 29
#define PREPROCESSOR_DECREMENT_IMPL_31 30
#define PREPROCESSOR_DECREMENT_IMPL_32 31
#define PREPROCESSOR_DECREMENT_IMPL_33 32
#define PREPROCESSOR_DECREMENT_IMPL_34 33
#define PREPROCESSOR_DECREMENT_IMPL_35 34
#define PREPROCESSOR_DECREMENT_IMPL_36 35
#define PREPROCESSOR_DECREMENT_IMPL_37 36
#define PREPROCESSOR_DECREMENT_IMPL_38 37
#define PREPROCESSOR_DECREMENT_IMPL_39 38
#define PREPROCESSOR_DECREMENT_IMPL_40 39
#define PREPROCESSOR_DECREMENT_IMPL_41 40
#define PREPROCESSOR_DECREMENT_IMPL_42 41
#define PREPROCESSOR_DECREMENT_IMPL_43 42
#define PREPROCESSOR_DECREMENT_IMPL_44 43
#define PREPROCESSOR_DECREMENT_IMPL_45 44
#define PREPROCESSOR_DECREMENT_IMPL_46 45
#define PREPROCESSOR_DECREMENT_IMPL_47 46
#define PREPROCESSOR_DECREMENT_IMPL_48 47
#define PREPROCESSOR_DECREMENT_IMPL_49 48
#define PREPROCESSOR_DECREMENT_IMPL_50 49
#define PREPROCESSOR_DECREMENT_IMPL_51 50
#define PREPROCESSOR_DECREMENT_IMPL_52 51
#define PREPROCESSOR_DECREMENT_IMPL_53 52
#define PREPROCESSOR_DECREMENT_IMPL_54 53
#define PREPROCESSOR_DECREMENT_IMPL_55 54
#define PREPROCESSOR_DECREMENT_IMPL_56 55
#define PREPROCESSOR_DECREMENT_IMPL_57 56
#define PREPROCESSOR_DECREMENT_IMPL_58 57
#define PREPROCESSOR_DECREMENT_IMPL_59 58
#define PREPROCESSOR_DECREMENT_IMPL_60 59
#define PREPROCESSOR_DECREMENT_IMPL_61 60
#define PREPROCESSOR_DECREMENT_IMPL_62 61
#define PREPROCESSOR_DECREMENT_IMPL_63 62
#define PREPROCESSOR_DECREMENT_IMPL_64 63
#define PREPROCESSOR_DECREMENT_IMPL_65 64
#define PREPROCESSOR_DECREMENT_IMPL_66 65
#define PREPROCESSOR_DECREMENT_IMPL_67 66
#define PREPROCESSOR_DECREMENT_IMPL_68 67
#define PREPROCESSOR_DECREMENT_IMPL_69 68
#define PREPROCESSOR_DECREMENT_IMPL_70 69
#define PREPROCESSOR_DECREMENT_IMPL_71 70
#define PREPROCESSOR_DECREMENT_IMPL_72 71
#define PREPROCESSOR_DECREMENT_IMPL_73 72
#define PREPROCESSOR_DECREMENT_IMPL_74 73
#define PREPROCESSOR_DECREMENT_IMPL_75 74
#define PREPROCESSOR_DECREMENT_IMPL_76 75
#define PREPROCESSOR_DECREMENT_IMPL_77 76
#define PREPROCESSOR_DECREMENT_IMPL_78 77
#define PREPROCESSOR_DECREMENT_IMPL_79 78
#define PREPROCESSOR_DECREMENT_IMPL_80 79
#define PREPROCESSOR_DECREMENT_IMPL_81 80
#define PREPROCESSOR_DECREMENT_IMPL_82 81
#define PREPROCESSOR_DECREMENT_IMPL_83 82
#define PREPROCESSOR_DECREMENT_IMPL_84 83
#define PREPROCESSOR_DECREMENT_IMPL_85 84
#define PREPROCESSOR_DECREMENT_IMPL_86 85
#define PREPROCESSOR_DECREMENT_IMPL_87 86
#define PREPROCESSOR_DECREMENT_IMPL_88 87
#define PREPROCESSOR_DECREMENT_IMPL_89 88
#define PREPROCESSOR_DECREMENT_IMPL_90 89
#define PREPROCESSOR_DECREMENT_IMPL_91 90
#define PREPROCESSOR_DECREMENT_IMPL_92 91
#define PREPROCESSOR_DECREMENT_IMPL_93 92
#define PREPROCESSOR_DECREMENT_IMPL_94 93
#define PREPROCESSOR_DECREMENT_IMPL_95 94
#define PREPROCESSOR_DECREMENT_IMPL_96 95
#define PREPROCESSOR_DECREMENT_IMPL_97 96
#define PREPROCESSOR_DECREMENT_IMPL_98 97
#define PREPROCESSOR_DECREMENT_IMPL_99 98
#define PREPROCESSOR_DECREMENT_IMPL_100 99
#define PREPROCESSOR_DECREMENT_IMPL_101 100
#define PREPROCESSOR_DECREMENT_IMPL_102 101
#define PREPROCESSOR_DECREMENT_IMPL_103 102
#define PREPROCESSOR_DECREMENT_IMPL_104 103
#define PREPROCESSOR_DECREMENT_IMPL_105 104
#define PREPROCESSOR_DECREMENT_IMPL_106 105
#define PREPROCESSOR_DECREMENT_IMPL_107 106
#define PREPROCESSOR_DECREMENT_IMPL_108 107
#define PREPROCESSOR_DECREMENT_IMPL_109 108
#define PREPROCESSOR_DECREMENT_IMPL_110 109
#define PREPROCESSOR_DECREMENT_IMPL_111 110
#define PREPROCESSOR_DECREMENT_IMPL_112 111
#define PREPROCESSOR_DECREMENT_IMPL_113 112
#define PREPROCESSOR_DECREMENT_IMPL_114 113
#define PREPROCESSOR_DECREMENT_IMPL_115 114
#define PREPROCESSOR_DECREMENT_IMPL_116 115
#define PREPROCESSOR_DECREMENT_IMPL_117 116
#define PREPROCESSOR_DECREMENT_IMPL_118 117
#define PREPROCESSOR_DECREMENT_IMPL_119 118
#define PREPROCESSOR_DECREMENT_IMPL_120 119
#define PREPROCESSOR_DECREMENT_IMPL_121 120
#define PREPROCESSOR_DECREMENT_IMPL_122 121
#define PREPROCESSOR_DECREMENT_IMPL_123 122
#define PREPROCESSOR_DECREMENT_IMPL_124 123
#define PREPROCESSOR_DECREMENT_IMPL_125 124
#define PREPROCESSOR_DECREMENT_IMPL_126 125
#define PREPROCESSOR_DECREMENT_IMPL_127 126
#define PREPROCESSOR_DECREMENT_IMPL_128 127
#define PREPROCESSOR_DECREMENT_IMPL_129 128
#define PREPROCESSOR_DECREMENT_IMPL_130 129
#define PREPROCESSOR_DECREMENT_IMPL_131 130
#define PREPROCESSOR_DECREMENT_IMPL_132 131
#define PREPROCESSOR_DECREMENT_IMPL_133 132
#define PREPROCESSOR_DECREMENT_IMPL_134 133
#define PREPROCESSOR_DECREMENT_IMPL_135 134
#define PREPROCESSOR_DECREMENT_IMPL_136 135
#define PREPROCESSOR_DECREMENT_IMPL_137 136
#define PREPROCESSOR_DECREMENT_IMPL_138 137
#define PREPROCESSOR_DECREMENT_IMPL_139 138
#define PREPROCESSOR_DECREMENT_IMPL_140 139
#define PREPROCESSOR_DECREMENT_IMPL_141 140
#define PREPROCESSOR_DECREMENT_IMPL_142 141
#define PREPROCESSOR_DECREMENT_IMPL_143 142
#define PREPROCESSOR_DECREMENT_IMPL_144 143
#define PREPROCESSOR_DECREMENT_IMPL_145 144
#define PREPROCESSOR_DECREMENT_IMPL_146 145
#define PREPROCESSOR_DECREMENT_IMPL_147 146
#define PREPROCESSOR_DECREMENT_IMPL_148 147
#define PREPROCESSOR_DECREMENT_IMPL_149 148
#define PREPROCESSOR_DECREMENT_IMPL_150 149
#define PREPROCESSOR_DECREMENT_IMPL_151 150
#define PREPROCESSOR_DECREMENT_IMPL_152 151
#define PREPROCESSOR_DECREMENT_IMPL_153 152
#define PREPROCESSOR_DECREMENT_IMPL_154 153
#define PREPROCESSOR_DECREMENT_IMPL_155 154
#define PREPROCESSOR_DECREMENT_IMPL_156 155
#define PREPROCESSOR_DECREMENT_IMPL_157 156
#define PREPROCESSOR_DECREMENT_IMPL_158 157
#define PREPROCESSOR_DECREMENT_IMPL_159 158
#define PREPROCESSOR_DECREMENT_IMPL_160 159
#define PREPROCESSOR_DECREMENT_IMPL_161 160
#define PREPROCESSOR_DECREMENT_IMPL_162 161
#define PREPROCESSOR_DECREMENT_IMPL_163 162
#define PREPROCESSOR_DECREMENT_IMPL_164 163
#define PREPROCESSOR_DECREMENT_IMPL_165 164
#define PREPROCESSOR_DECREMENT_IMPL_166 165
#define PREPROCESSOR_DECREMENT_IMPL_167 166
#define PREPROCESSOR_DECREMENT_IMPL_168 167
#define PREPROCESSOR_DECREMENT_IMPL_169 168
#define PREPROCESSOR_DECREMENT_IMPL_170 169
#define PREPROCESSOR_DECREMENT_IMPL_171 170
#define PREPROCESSOR_DECREMENT_IMPL_172 171
#define PREPROCESSOR_DECREMENT_IMPL_173 172
#define PREPROCESSOR_DECREMENT_IMPL_174 173
#define PREPROCESSOR_DECREMENT_IMPL_175 174
#define PREPROCESSOR_DECREMENT_IMPL_176 175
#define PREPROCESSOR_DECREMENT_IMPL_177 176
#define PREPROCESSOR_DECREMENT_IMPL_178 177
#define PREPROCESSOR_DECREMENT_IMPL_179 178
#define PREPROCESSOR_DECREMENT_IMPL_180 179
#define PREPROCESSOR_DECREMENT_IMPL_181 180
#define PREPROCESSOR_DECREMENT_IMPL_182 181
#define PREPROCESSOR_DECREMENT_IMPL_183 182
#define PREPROCESSOR_DECREMENT_IMPL_184 183
#define PREPROCESSOR_DECREMENT_IMPL_185 184
#define PREPROCESSOR_DECREMENT_IMPL_186 185
#define PREPROCESSOR_DECREMENT_IMPL_187 186
#define PREPROCESSOR_DECREMENT_IMPL_188 187
#define PREPROCESSOR_DECREMENT_IMPL_189 188
#define PREPROCESSOR_DECREMENT_IMPL_190 189
#define PREPROCESSOR_DECREMENT_IMPL_191 190
#define PREPROCESSOR_DECREMENT_IMPL_192 191
#define PREPROCESSOR_DECREMENT_IMPL_193 192
#define PREPROCESSOR_DECREMENT_IMPL_194 193
#define PREPROCESSOR_DECREMENT_IMPL_195 194
#define PREPROCESSOR_DECREMENT_IMPL_196 195
#define PREPROCESSOR_DECREMENT_IMPL_197 196
#define PREPROCESSOR_DECREMENT_IMPL_198 197
#define PREPROCESSOR_DECREMENT_IMPL_199 198
#define PREPROCESSOR_DECREMENT_IMPL_200 199
#define PREPROCESSOR_DECREMENT_IMPL_201 200
#define PREPROCESSOR_DECREMENT_IMPL_202 201
#define PREPROCESSOR_DECREMENT_IMPL_203 202
#define PREPROCESSOR_DECREMENT_IMPL_204 203
#define PREPROCESSOR_DECREMENT_IMPL_205 204
#define PREPROCESSOR_DECREMENT_IMPL_206 205
#define PREPROCESSOR_DECREMENT_IMPL_207 206
#define PREPROCESSOR_DECREMENT_IMPL_208 207
#define PREPROCESSOR_DECREMENT_IMPL_209 208
#define PREPROCESSOR_DECREMENT_IMPL_210 209
#define PREPROCESSOR_DECREMENT_IMPL_211 210
#define PREPROCESSOR_DECREMENT_IMPL_212 211
#define PREPROCESSOR_DECREMENT_IMPL_213 212
#define PREPROCESSOR_DECREMENT_IMPL_214 213
#define PREPROCESSOR_DECREMENT_IMPL_215 214
#define PREPROCESSOR_DECREMENT_IMPL_216 215
#define PREPROCESSOR_DECREMENT_IMPL_217 216
#define PREPROCESSOR_DECREMENT_IMPL_218 217
#define PREPROCESSOR_DECREMENT_IMPL_219 218
#define PREPROCESSOR_DECREMENT_IMPL_220 219
#define PREPROCESSOR_DECREMENT_IMPL_221 220
#define PREPROCESSOR_DECREMENT_IMPL_222 221
#define PREPROCESSOR_DECREMENT_IMPL_223 222
#define PREPROCESSOR_DECREMENT_IMPL_224 223
#define PREPROCESSOR_DECREMENT_IMPL_225 224
#define PREPROCESSOR_DECREMENT_IMPL_226 225
#define PREPROCESSOR_DECREMENT_IMPL_227 226
#define PREPROCESSOR_DECREMENT_IMPL_228 227
#define PREPROCESSOR_DECREMENT_IMPL_229 228
#define PREPROCESSOR_DECREMENT_IMPL_230 229
#define PREPROCESSOR_DECREMENT_IMPL_231 230
#define PREPROCESSOR_DECREMENT_IMPL_232 231
#define PREPROCESSOR_DECREMENT_IMPL_233 232
#define PREPROCESSOR_DECREMENT_IMPL_234 233
#define PREPROCESSOR_DECREMENT_IMPL_235 234
#define PREPROCESSOR_DECREMENT_IMPL_236 235
#define PREPROCESSOR_DECREMENT_IMPL_237 236
#define PREPROCESSOR_DECREMENT_IMPL_238 237
#define PREPROCESSOR_DECREMENT_IMPL_239 238
#define PREPROCESSOR_DECREMENT_IMPL_240 239
#define PREPROCESSOR_DECREMENT_IMPL_241 240
#define PREPROCESSOR_DECREMENT_IMPL_242 241
#define PREPROCESSOR_DECREMENT_IMPL_243 242
#define PREPROCESSOR_DECREMENT_IMPL_244 243
#define PREPROCESSOR_DECREMENT_IMPL_245 244
#define PREPROCESSOR_DECREMENT_IMPL_246 245
#define PREPROCESSOR_DECREMENT_IMPL_247 246
#define PREPROCESSOR_DECREMENT_IMPL_248 247
#define PREPROCESSOR_DECREMENT_IMPL_249 248
#define PREPROCESSOR_DECREMENT_IMPL_250 249
#define PREPROCESSOR_DECREMENT_IMPL_251 250
#define PREPROCESSOR_DECREMENT_IMPL_252 251
#define PREPROCESSOR_DECREMENT_IMPL_253 252
#define PREPROCESSOR_DECREMENT_IMPL_254 253
#define PREPROCESSOR_DECREMENT_IMPL_255 254
#define PREPROCESSOR_DECREMENT_IMPL_256 255

/* -- Macros -- */

#define PREPROCESSOR_INCREMENT_IMPL(expr) PREPROCESSOR_INCREMENT_IMPL_ ## expr
#define PREPROCESSOR_DECREMENT_IMPL(expr) PREPROCESSOR_DECREMENT_IMPL_ ## expr

#if defined(__MWERKS__)
#	define PREPROCESSOR_INCREMENT_TOKEN(expr) PREPROCESSOR_INCREMENT_IMPL ## expr
#	define PREPROCESSOR_INCREMENT(expr) PREPROCESSOR_INCREMENT_TOKEN((expr))
#	define PREPROCESSOR_DECREMENT_TOKEN(expr) PREPROCESSOR_DECREMENT_IMPL ## expr
#	define PREPROCESSOR_DECREMENT(expr) PREPROCESSOR_DECREMENT_TOKEN((expr))
#else
#	define PREPROCESSOR_INCREMENT(expr) PREPROCESSOR_INCREMENT_IMPL(expr)
#	define PREPROCESSOR_DECREMENT(expr) PREPROCESSOR_DECREMENT_IMPL(expr)
#endif

#ifdef __cplusplus
}
#endif

#endif /* PREPROCESSOR_ARITHMETIC_H */
